''Second attempt at a train bell demo
''
''Useful info on SID chip:
''http://sid.kubarth.com/

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    


OBJ
  SID  : "SIDCog"
  kb   : "keyboard"


pub letsDoIt|tmp

  SID.start(10,11)                       'Start SID in cog 1 (supposedly better sound quality per Jon/Chip) 
  SID.resetRegisters                     'Reset all SID registers
  kb.start(26, 27)

  SID.setVolume(5)                   
  SID.setResonance(15)
  SID.setCutoff(250)

  SID.setWaveform(2, SID#TRIANGLE)      
  SID.setADSR(0, 7, 4, 8, 9)             
  SID.setADSR(1, 7, 4, 8, 9)             
  SID.setADSR(2, 0, 0, 6, 9)             

                    'Lp     Bp    Hp    
  SID.setFilterType(false, false, true)  

                    'Ch1   Ch2   Ch3      
  SID.setFilterMask(true, false, true)  
{
  repeat
    tmp:=kb.getkey
    SID.noteOn(2, freq2word(400))
'    SID.noteOn(1, freq2word(600))
'    SID.noteOn(0, freq2word(400))

'    SID.enableRingmod(TRUE,TRUE,TRUE)
'     SID.enableSynchronization(TRUE,TRUE,TRUE)
    waitcnt(cnt+clkfreq/4)
    SID.noteOff(2)
}
    repeat   
      if cnt & (%1 <- 25)                         'toggle bell sound w/ cnt bit 25 (~1/sec @ 80MHz)
        SID.play(1,freq2word(400),SID#TRIANGLE,0, 0, 6, 9)
        SID.noteOff(1)


pri freq2word(freq)|tmp
'converts frequency (Hz) to 16-bit value

tmp := 65536/3900*freq
tmp := 0#> tmp <#65536
return tmp

      